<?php

namespace Ulmus\Ldap;

use Ulmus\Ulmus;
use Ulmus\Annotation\Property\{ Where, Having, Relation, Join, WithJoin, Relation\Ignore as RelationIgnore };
use Ulmus\Common\EntityResolver;

class Repository extends \Ulmus\Repository
{
    const DEFAULT_ALIAS = "";

    public array $events = [];

    public function __construct(string $entity, string $alias = self::DEFAULT_ALIAS, ConnectionAdapter $adapter = null) {
        parent::__construct($entity, $alias, $adapter);

        $this->queryBuilder = new QueryBuilder();
    }
    
    protected function selectSqlQuery() : self
    {
        if ( null === $this->queryBuilder->getFragment(Query\Select::class) ) {
            $this->select(array_keys($this->entityResolver->fieldList(EntityResolver::KEY_COLUMN_NAME)));
        }
        
        return $this;
    }

}